/*****************************************************
*Description: This is an example program to demonstrate
*reading and writing to DIO pins on the TS-5500. This 
*program assumes DIO1_0 is connected to DIO1_13. This  
*program sets DIO1_0 as an output then it prompts the
*user to set or clear DIO1_0. Next it reads DIO1_13
*and prints if the pin is set or clear.
*
*Note: DIO1_13 is always an input so there is no need
*to set a control bit for read.
*****************************************************/


#include <stdio.h>
#include <sys/io.h>

int main()
{
	int ioval;
	char userInput;

	if(ioperm(0x7A, 4, 1) < 0)
	{
		printf("Error gaining access to 0x7A\n");
		return -1;
	}

	//set pins 0 to 3 to outputs
	ioval = inb(0x7A);
	ioval = ioval | 0x01;
	outb(ioval, 0x7A);
	printf("Set DIO1_0 - DIO1_3 to be outputs\n");

	if(ioperm(0x7B, 8, 1) < 0)
	{
		printf("Error gaining access to 0x7B");
		return -1;
	}

   if(ioperm(0x7C, 8, 1) < 0)
   {
      printf("Error gaining access to 0x7C");
      return -1;
   }


	printf("--------------------------------");
	printf("\nPress \n\tx to exit,\n\t0 to set DIO1_0 to logic 0\n\t1 to set DIO1_0 to logic 1\n");
   printf("--------------------------------\n#");

	userInput = getchar();

	while(userInput != 'x')
	{
		if(userInput == '1')
		{
			printf("Turning On DIO1_0");

   		ioval = inb(0x7B);
   		ioval = ioval | 0x01;
   		outb(ioval, 0x7B);
		}
		else if(userInput == '0')
		{
			printf("Turning Off DIO1_0");
	   
	  	 	ioval = inb(0x7B);
   		ioval = ioval & 0xFE;
   		outb(ioval, 0x7B);
		}
		else if(userInput != '\n')
		{
			printf("Invalid input please try again...\n");
		}

		if(userInput != '\n')
		{

      	//read in pin 13
      	ioval = inb(0x7C);
                                                              
      	//check if bit 6 is set
      	ioval = ioval & 0x20;
                                                              
      	if(ioval == 0x20)
         	printf("\nDIO1_13 is on\n");
      	else
         	printf("\nDIO1_13 is off\n");

			printf("\n#");	
		}
		userInput = getchar();
	}
	return 0;
}
