/*
 * readkeypad.c
 * (c) Technologic System's (info@embeddedx86.com)
 * 	Liberty Young (liberty _AT__ embeddedx86 /DOT/com)
 *
 * Technologic Systems makes no warranties with this code; 
 * it is provided AS-IS. This code was developed
 * for use in a Technologic Systems' Single Board Computer of the
 * 3x00 and 5x00 series.
 *
 * Technologic Systems' sample application code
 * This sample user application makes use of the ts_keypad.o device driver
 * It simply reads from the keypad, printing out the results, until the 
 * Button '#' is pressed .
 */


#include <fcntl.h>
#include <stdio.h>
#include <unistd.h>
#include <errno.h>
#include <string.h>
#include <sys/time.h>

int main (void)
{
	char buf[0]; 
	int rtrn = 0; 
	buf[0] = 0;
	char *devname = "/dev/TSKeypad" ;
	int requestedlength;
	struct timeval tv1, tv2; 
	struct timezone ignore; 

	int fd = open (devname, O_RDWR);
	requestedlength = sizeof(char);

	printf("Starting Technologic Systems' Matrix Keypad Example Program\n");

	if (fd < 0) {
		printf("the TS MatrixKeypad device can not be found..is the driver loaded?\n");
		printf("error val: %d ", fd);
		printf ("Errno: %s \n", strerror(errno)    );
		return errno;
	}

	printf("testing continous read of device\n");
	while (buf[0] != '#') {
		rtrn = read (fd, &buf, sizeof(char));
		if (rtrn < 0 )
			printf ("Errno: %s \n", strerror(errno));

		if (!rtrn) {
			buf[0] = '\0';
			continue;
		}
		printf("Found Key: %c\n", buf[0]);
	}

	printf("Now we'll test the 'buffered' feature of the driver\n");
	
	//psuedo sleep for 3 second
	gettimeofday(&tv1, &ignore);

	printf("Remeber, the driver will recognize any and all keypress\n");
	printf("As long as the device file is in OPEN\n");

    do {
       gettimeofday(&tv2, &ignore);
    }while ( tv2.tv_sec  < (3+tv1.tv_sec));
	
	rtrn = read (fd, &buf, sizeof(char)) ;
	
	while (rtrn > 0)  {
		printf("Found Key: %c\n", buf[0]);
		rtrn = read (fd, &buf, sizeof(char)) ;
	}

	printf("goodbye!");
	return 0;
}
